"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var govern_1 = require("govern");
function createStore(element, render) {
    return Store.Element({ element: element, render: render });
}
exports.createStore = createStore;
/**
 * Accepts an observable as a prop, and passes each of its values to the
 * component's children via a render function.
 *
 * NOTE: this component should be generic on output type, but TSX doesn't
 * properly support generic components. In the meantime, if you want
 * typing, use the `createSubscribe` factory.
 *
 * See https://github.com/Microsoft/TypeScript/issues/14729.
 */
var Store = /** @class */ (function (_super) {
    __extends(Store, _super);
    function Store(props) {
        var _this = _super.call(this, props) || this;
        _this.observable = govern_1.createObservable(govern_1.createElement(Binding, { initialElement: _this.props.element }));
        return _this;
    }
    Store.Element = function (props) {
        return React.createElement(Store, props);
    };
    Store.prototype.componentWillMount = function () {
        if (!this.props.element) {
            console.warn("An \"element\" prop must be provided to <Observable> but \"" + this.props.element + "\" was received.");
        }
    };
    Store.prototype.UNSAFE_componentWillReceiveProps = function (nextProps) {
        if (!nextProps.element) {
            console.warn("A \"element\" prop must be provided to <Observable> but \"" + this.props.element + "\" was received.");
        }
        // As elements are immutable, we can skip a lot of updates by
        // checking if the `to` element/store has changed.
        if (nextProps.element !== this.props.element) {
            this.observable.getValue().changeElement(nextProps.element);
        }
    };
    Store.prototype.componentDidCatch = function (error) {
        this.disposeStore();
    };
    Store.prototype.componentWillUnmount = function () {
        this.disposeStore();
    };
    Store.prototype.disposeStore = function () {
        if (this.observable) {
            this.observable.dispose();
            delete this.observable;
        }
    };
    Store.prototype.render = function () {
        var render = (this.props.children || this.props.render);
        return render(this.observable);
    };
    return Store;
}(React.Component));
exports.Store = Store;
var Binding = /** @class */ (function (_super) {
    __extends(Binding, _super);
    function Binding(props) {
        var _this = _super.call(this, props) || this;
        _this.changeElement = function (element) {
            _this.setState({
                element: element,
            });
        };
        _this.state = {
            element: _this.props.initialElement
        };
        return _this;
    }
    Binding.prototype.render = function () {
        return govern_1.combine({
            snapshot: this.state.element,
            changeElement: this.changeElement,
        });
    };
    Binding.prototype.getPublishedValue = function () {
        this.subs;
        return this.subs;
    };
    Binding.prototype.shouldComponentPublish = function (prevProps, prevState, prevSubs) {
        return prevSubs.snapshot !== this.subs.snapshot;
    };
    return Binding;
}(govern_1.Component));
//# sourceMappingURL=Store.js.map