"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var govern_1 = require("govern");
var Store_1 = require("./Store");
/**
 * A Higher Order Component version of the <Store of /> component.
 */
exports.withStore = function (mapOwnPropsToElement, propName) {
    if (propName === void 0) { propName = 'store'; }
    var mapFn = mapOwnPropsToElement;
    if (govern_1.isValidElement(mapOwnPropsToElement)) {
        mapFn = (function () { return mapOwnPropsToElement; });
    }
    else if (mapOwnPropsToElement instanceof govern_1.Component.constructor) {
        mapFn = function (props) { return govern_1.createElement(mapOwnPropsToElement, props); };
    }
    if (typeof mapFn !== 'function') {
        throw new Error("\"govern(..., mapFn)\" received an unknown \"mapFn\" of type \"" + typeof mapFn + "\" for \"" + String(mapOwnPropsToElement) + "\".");
    }
    var decorator = function (WrappedComponent) {
        // Use a class component instead of a stateless functional component so
        // that consumers can use refs if they need.
        return /** @class */ (function (_super) {
            __extends(SubscribeWrapper, _super);
            function SubscribeWrapper() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            SubscribeWrapper.prototype.render = function () {
                var _this = this;
                return Store_1.Store.Element({
                    element: mapFn(this.props),
                    children: function (store) {
                        var _a;
                        return React.createElement(WrappedComponent, __assign({}, _this.props, (_a = {}, _a[propName] = store, _a)));
                    }
                });
            };
            return SubscribeWrapper;
        }(React.Component));
    };
    return decorator;
};
//# sourceMappingURL=withStore.js.map